#include "libdef.inc"
#include <cv/dos.h>
#if !defined(STD_CODE) && defined(ASM86_CODE)
# include <cv/asm86.h>
#endif
#include <cv/cpphelp.h>
#include <cv/fnutil.h>


static count		fnUpperLen = 0;
static const char far*	fnUpper;


static void SMALL_ initUpperTbl(){
	if(fnUpperLen) return;

	struct MapTbl { word len; char tbl[]; };
	struct MapTblPtr { byte id; MapTbl far* tbl; } buf;

#if defined(STD_CODE) || !defined(ASM86_CODE)

	REGS r; SREGS sr;
	r.x.di = FP_OFF(&buf); sr.es = FP_SEG(&buf); r.x.cx = sizeof(buf);
	r.x.dx = r.x.bx = -1; r.x.ax = 0x6504;
	intdosx(&r, &r, &sr); if(r.x.cflag) return;
	fnUpperLen = buf.tbl->len + 128; fnUpper = buf.tbl->tbl;
#else
	_DI = FP_OFF(&buf); _ES = FP_SEG(&buf);
	_CX = sizeof(buf); _BX = _DX = -1; _AX = 0x6504;
	I int 0x21; if(isFLAG(Carry)) return;

	I les bx, dword(buf.(MapTblPtr)tbl);
	fnUpperLen = ((MapTbl far*)MK_FP(_ES, _BX))->len + 128;

	_BX++; _BX++;			/* BX = FP_OFF(buf.tbl->tbl) */
	fnUpper = (const char far*)MK_FP(_ES, _BX);
#endif
}

/* "Check for stack overflow" off for BC++ 3.1 */
#pragma option -N-

/*----------------------------------------------------------------------*/
/* ८ࠧ  孥 ॣ  ᮮ⢥⢨  ࠢ MS-DOS	*/
void FAST_ fnUppercase(void *path, size_t sz){
	initUpperTbl();
	for(; sz; sz--){
		count ch = *(byte*)path;
		if(ch < 128){		doupper(ch);
		}elif(ch < fnUpperLen)	ch = fnUpper[ch - 128];
		*((byte*)path)++ = ch;
}	}
